;Gruppe:	
$NOMOD51
$INCLUDE (REG517A.inc)
EXTRN	CODE(Iniser0, PutChar, GetChar)
		
;-----------------------Hauptprogramm-----------------------
start:
		CLR a				;Akku lschen, alles wird auf NULL gesetzt
		mov ADCON0,a  			;A/D-Wandler Steuerregister 0 mit Akku verbinden ?
		mov 0DAH,#00H			;+Ref auf 5V setzen, quasi Standard -> weglassen ? Nein !
		call Iniser0			; Serielle Schnittstelle 0 initialisieren


busy:
		jb 0DCH,busy  			;Iss Adcon1,und Busy-Flag von Adcon0 ?, 1=busy, Endlosschleife, sofern es gesetzt ist
		mov a,ADDATH 			;Higher Byte vom A/D in den Akku laden
		mov p4,a			;Inhalt von a auf P4 ausgeben
		mov	MD0,a			; low multiplikant	
		mov	MD4,#0C4h		; low multiplikator
		mov	MD1,#00000000b		; high multiplikant
		mov	MD5,#00h		; high multiplikator
		acall nop4x
		mov 	R1,MD0			; low produkt
		mov	R2,MD1			; high produkt
		acall nop4x
		mov MD0, R1	   		; low produkt erneut in die MDU
		mov MD1, R2   			; high produkt ebenfalls in die MDU
		mov MD4,#00001010b 		; Divisor 10 (low)
		mov MD5,#00000000b 		; Divisor 0 (high)
		acall nop4x
		mov R1, MD0  			; Quotient auf R1 legen (low)
		mov R2, MD1			; Quotient auf R2 legen (high)
		acall nop4x
		clr c					;carry flag lschen
		mov a,r1				;inhalt von register 1 in a schieben
		add a,#2     			; increment register 
		mov r1,a				;von a in R1
		mov a,r2				;von R2 in a
		addc a,#0				;zu a Null addieren (carry flag aus vorhergehender rechnung wird mit addiert)
		mov r2,a				;von a in R2
		mov MD0, R1 			; low bit in die MDU
		mov MD1, R2 			; high bit in die MDu
		mov MD4, #00001010b		; Divisor 10 (low)
		mov MD5, #00000000b 		; Divisor 0 (high)
		acall nop4x
		mov R1, MD0  			; Quotient auf R1 legen (low)
		mov R2, MD1  			; Quotient auf R2 legen (high)

; ------------------ASCII-Konvertierung---------------------

        mov MD0, R1	   			; low erneut in die MDU
		mov MD1, R2    			; high ebenfalls in die MDU
		mov MD4,#01100100b 		; Divisor 100 (low)
		mov MD5,#00000000b 		; Divisor 0 (high)
		acall nop4x			  	; Warten
		mov a, md0		  	; Hunderter in den Akku
		add a,#30h		  	; Addition mit 30H (ASCII fr null)
		mov r3,a		  	; Rein in R3

		mov md0,md4		  	; Rest der vorherigen Division in Low Divisor
		mov md1,#0		  	; High Devisor auf 0
		mov md4,#00001010b		; Divisor 10 (low)
		mov MD5, #00000000b 		; Divisor 0 (high)
		acall nop4x			; Warte
		mov a,md0			; von md0 in a
		add a,#30h			; addiere 30h zu a um in den gltigen Zahlen Bereich der ASCII tabelle zu kommen
		mov r4,a			; Zehner Ascii in r4

		mov a, md4			; Rest ist der Einer, ab zur Addition mit 30H in den Akku
		add a,#30h
		mov r5,a			; Einer geht dann in r5

 ; -----------------Ausgabe via PutChar----------------------
		mov a,R3			;von R3 in a
		mov R7,a			;zur ausgabe inhalt von a in R7 schieben
		call PutChar	  	; Ausgabe des Hunderters
		
		mov R7,#2EH			;ASCII code des ","
		call PutChar	  	; Ausgabe des Komma
				
		mov a,R4
		mov R7,a
		call PutChar	  	; Ausgabe des Zehners
		
		mov a,R5
		mov R7,a
		call PutChar	  	; Ausgabe des Einers
		
		mov R7,#0aH
		call PutChar	  	; Zeilenumbruch
		
warte:	      	call GetChar			; Tastaturabfrage
		mov	a,R7			; Register R7 als Uebergaberegister
		clr	c			; clear carry-flag		
		subb	a,#20h			; Leertaste subtrahieren
		jnz	warte			; wenn leertaste, dann weiter, sonst warte





		acall wait1s		; Sekndchen warten ! Obs funzt ?
ljmp start

nop4x:
	Nop
	Nop
	Nop
	Nop
ret

wait1s:				  ; Eine Sekunde Warten ! 
	
ret


end